c density distribution by Negele
c only for quadrupole transition
c collective vibration model
c  rho_tr(r)=d/dr (rho0(\vect(r))*crho*beta  -- care
c only for  0+ -> J\pi  transition
c   
c  2008.Oct.29.  if beta<0, beta --> delta
c
      implicit double precision (a-h,o-z)
c
      dimension rgauss(50),amp(50),nost(60),spin(60),numb(60),energ(60)
      dimension rho(1000)
      character*1 ip(60)
      character*5 symbol
      character*20 fout
c
c      open(1,file='negele+vib2.dat')
c
      read(5,145) symbol,nkaku,irmax,dr,ifmt
      write(6,245) symbol,nkaku,irmax,dr
  145 format(a5,9x,i2,10x,i4,5x,f8.0,6x,i2)
  245 format(a5,'   nkaku=',i2,'   irmax =',i4,'  dr=',f8.3)

      if(nkaku.gt.2) stop'nkaku<3'

      do 150 nk=1,nkaku
      read(5,146) nost(nk),spin(nk),ip(nk),numb(nk),energ(nk)
      write(6,146) nost(nk),spin(nk),ip(nk),numb(nk),energ(nk)
  150 continue   
  146 format(i5,f5.1,4x,a1,i5,5x,f5.2)

      lamx=idnint(spin(2)-spin(1))
c
      read(5,*) fout
      read(5,*) amass,pnmass,crho,beta
      write(6,*) fout
      write(6,*) amass,pnmass,crho,beta !,crho*beta
      write(6,*) 'lambda=',lamx

      open(2,file=fout)
      write(2,245) symbol,nkaku,irmax,dr
      do nk=1,nkaku
        write(2,146) nost(nk),spin(nk),ip(nk),numb(nk),energ(nk)
      enddo
c
      beki=1.0d0/3.0d0
      pai=3.141592653589793d0
c
      arho=0.54d0
      if(crho.eq.0.0) crho=(0.978d0+0.0206d0*amass**beki)*amass**beki
      write(6,*) 'R0=',crho

c added for beta<0
      if(beta.ge.0.0) delta=beta*crho
      if(beta.lt.0.0) delta=dabs(beta)
      write(6,*) 'delta=',delta

      paiac=( pai*arho/crho )**2
      bunbo=4.0d0*pai*crho**3*(1.0d0+paiac)
      rho0=3.0d0*pnmass/bunbo
c
c -- diagonal --
      write(2,259) 1,1,1,0
      write(6,259) 1,1,1,0
  259 format('no=',i4,'     ka=',i2,'   kb=',i2,'   lam=',i2)
      skbn=0.0d0
      rmsr=0.0d0
      do 100 ir=1,irmax
        r=dble(ir-1)*dr
        xx=(r-crho)/arho
        if(xx.gt.20) then
          rho(ir)=0.0d0
        else
          rho(ir)=dsqrt(4.0d0*pai)*rho0/(1.0d0+dexp(xx))
        end if
        if(ifmt.eq.0) then
          write(2,101) rho(ir)
        else if(ifmt.eq.1) then
          write(2,102) r,rho(ir)
        endif
        write(6,102) r,rho(ir)
        skbn=skbn+rho(ir)*r**2*dr
        rmsr=rmsr+rho(ir)*r**4*dr
  100 continue
c  101 format(1pd18.10)
  101 format(1pd12.4)
  102 format(f8.3,1pd12.4)
c
      factor=-1.0d0/dsqrt(2.0d0*dble(lamx)+1.0d0)
c -- transition --
      write(2,259) 2,2,1,lamx
      write(6,259) 2,2,1,lamx
      be2=0.0d0
      do ir=1,irmax
        r=dble(ir-1)*dr
        xx=(r-crho)/arho
        if(xx.gt.20) then
          rhotr=0.0d0
        else
          rhotr=rho0/arho*dexp(xx)/(1.0d0+dexp(xx))**2*delta*factor
        end if
        if(ifmt.eq.0) then
          write(2,101) rhotr
        else
          write(2,102) r,rhotr
        endif
        write(6,102) r,rhotr
        be2=be2+rhotr*r**(2+lamx)*dr
      enddo
c
c -- diagonal --
      write(2,259) 3,2,2,0
      do ir=1,irmax
        r=dble(ir-1)*dr
        if(ifmt.eq.0) then
          write(2,101) rho(ir)
        else
          write(2,102) r,rho(ir)
        endif
      enddo
      write(2,259) 4,2,2,2
      do ir=1,irmax
        r=dble(ir-1)*dr
        if(ifmt.eq.0) then
          write(2,101) 0.0d0
        else
          write(2,102) r,0.0d0
        endif
      enddo
c--------------

      write(6,*) 'for diagonal'
      write(6,*) 'norm=',skbn*dsqrt(4.0d0*pai)
      write(6,*) 'rmsr=',dsqrt(rmsr/skbn)
      write(6,*) 'for transition'
      write(6,*) 'B(E',lamx,' up)=',be2**2*(2.0d0*dble(lamx)+1.0d0),
     &                                               '  [e^2fm^(2*lam)]'
      stop
      end
